"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
require("./lib/awesomplete/awesomplete.js");
require('style-loader!./lib/awesomplete/awesomplete.css');
exports.AUTOCOMPLETE_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return AwesompleteComponent; }),
    multi: true,
};
var AwesompleteComponent = (function () {
    function AwesompleteComponent(elemRef, renderer) {
        this.elemRef = elemRef;
        this.renderer = renderer;
        this._list = [];
        this._options = {
            list: this.list
        };
    }
    Object.defineProperty(AwesompleteComponent.prototype, "list", {
        get: function () {
            return this._list;
        },
        set: function (value) {
            if (this._$renderedElem) {
                this._$renderedElem.list = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AwesompleteComponent.prototype, "options", {
        get: function () {
            return this._options;
        },
        set: function (value) {
            this._options = Object.assign(value, { list: this.list });
        },
        enumerable: true,
        configurable: true
    });
    AwesompleteComponent.prototype.ngOnInit = function () {
        if (this.list && this.list.length > 0) {
            this.options.list = this.list;
        }
        this._$elem = this.elemRef.nativeElement.querySelectorAll('input')[0];
        this.render(this._$elem, this.list);
    };
    AwesompleteComponent.prototype.render = function ($elem, list) {
        this._$renderedElem = new Awesomplete($elem, this.options);
    };
    AwesompleteComponent.prototype.writeValue = function (obj) {
        if (this._$elem) {
            this.renderer.setProperty(this._$elem, 'value', obj);
        }
    };
    AwesompleteComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    AwesompleteComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    AwesompleteComponent.prototype.setDisabledState = function (isDisabled) {
        this.renderer.setAttribute(this._$elem, 'disabled', isDisabled ? 'true' : 'false');
    };
    AwesompleteComponent.prototype.change = function ($event) {
        this.onChange($event.target.value);
        this.onTouched($event.target.value);
    };
    return AwesompleteComponent;
}());
__decorate([
    core_1.ViewChild('input'),
    __metadata("design:type", Object)
], AwesompleteComponent.prototype, "input", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], AwesompleteComponent.prototype, "list", null);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], AwesompleteComponent.prototype, "options", null);
AwesompleteComponent = __decorate([
    core_1.Component({
        selector: 'ng2-awesomplete',
        templateUrl: './auto-complete.component.html',
        providers: [exports.AUTOCOMPLETE_VALUE_ACCESSOR],
        styleUrls: ['./auto-complete.component.less']
    }),
    __metadata("design:paramtypes", [core_1.ElementRef,
        core_1.Renderer2])
], AwesompleteComponent);
exports.AwesompleteComponent = AwesompleteComponent;
//# sourceMappingURL=auto-complete.component.js.map